-- main.vhd
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity pwm is
    Port ( 

        CLK_in:     in std_logic;
        PWM_in:     in std_logic_vector(9 downto 0);
        PWM_load:   in std_logic;
        PWM_reset:  in std_logic;
        PWM_out :   out std_logic
        
        );
end pwm; 


architecture Behavioral of pwm is
 


component counter is

    Port (
        CLK_in : in std_logic; 
        RST : in std_logic;
        Q : out std_logic_vector (9 downto 0)
        ); 
end component;

component register10bit is 
    Port (
        D: in std_logic_vector(9 downto 0);
        CLK_in: in std_logic;
        LOAD: in std_logic;
        Q: out std_logic_vector(9 downto 0)
    );
end component;


component comparator is
Port (
        CLK_in:     in  std_logic;
        A:          in  std_logic_vector(9 downto 0);
        B:          in  std_logic_vector(9 downto 0); 
        CMP_OUT:    out std_logic
        
     ); 
end component;

 
signal CLK_div : std_logic;
signal cmp_in1 : std_logic_vector (9 downto 0);
signal cmp_in2 : std_logic_vector (9 downto 0);
signal cmp_out : std_logic;

begin
 
   
    ct : counter
    port map (CLK_in => CLK_in, RST => PWM_reset , Q => cmp_in2);

    reg: register10bit
    port map (CLK_in => CLK_in, LOAD => PWM_load, D=>PWM_in, Q=>cmp_in1);


    cmp: comparator
    port map(CLK_in => CLK_in, A => cmp_in2, B => cmp_in1, CMP_OUT => cmp_out);


    PWM_out <= not cmp_out;

end Behavioral;